# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .utils.base_model import BaseModel


@JsonMap(
    {
        "e_tag": "ETag",
        "last_modified": "LastModified",
        "part_number": "PartNumber",
        "size": "Size",
    }
)
class DirectUploadListPart(BaseModel):
    """DirectUploadListPart

    :param e_tag: `etag` of the part returned after uploading it.
    :type e_tag: str
    :param last_modified: The timestamp this part was last modified.
    :type last_modified: str
    :param part_number: The number of the part.
    :type part_number: int
    :param size: Size of the part in bytes.
    :type size: int
    """

    def __init__(self, e_tag: str, last_modified: str, part_number: int, size: int):
        """DirectUploadListPart

        :param e_tag: `etag` of the part returned after uploading it.
        :type e_tag: str
        :param last_modified: The timestamp this part was last modified.
        :type last_modified: str
        :param part_number: The number of the part.
        :type part_number: int
        :param size: Size of the part in bytes.
        :type size: int
        """
        self.e_tag = self._define_str("e_tag", e_tag, min_length=1)
        self.last_modified = last_modified
        self.part_number = part_number
        self.size = self._define_number("size", size, ge=1, le=9223372036854776000)
