# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .utils.base_model import BaseModel


@JsonMap({})
class Pagination(BaseModel):
    """Pagination response schema

    Used to serialize pagination metadata.
    Its main purpose is to document the pagination metadata.

    :param limit: How many rows to return in each page., defaults to None
    :type limit: int, optional
    :param next_page: Token for the next page., defaults to None
    :type next_page: str, optional
    :param page: The current page.
    :type page: str
    :param prev_page: Token for the previous page., defaults to None
    :type prev_page: str, optional
    """

    def __init__(
        self, page: str, limit: int = None, next_page: str = None, prev_page: str = None
    ):
        """Pagination response schema

        Used to serialize pagination metadata.
        Its main purpose is to document the pagination metadata.

        :param limit: How many rows to return in each page., defaults to None
        :type limit: int, optional
        :param next_page: Token for the next page., defaults to None
        :type next_page: str, optional
        :param page: The current page.
        :type page: str
        :param prev_page: Token for the previous page., defaults to None
        :type prev_page: str, optional
        """
        if limit is not None:
            self.limit = self._define_number("limit", limit, ge=20, le=1000)
        if next_page is not None:
            self.next_page = self._define_str("next_page", next_page, nullable=True)
        self.page = page
        if prev_page is not None:
            self.prev_page = self._define_str("prev_page", prev_page, nullable=True)
