# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .utils.base_model import BaseModel
from .player_logo_position import PlayerLogoPosition
from .player_skin import PlayerSkin


@JsonMap({"id_": "id"})
class Player(BaseModel):
    """Player

    :param created_on: Timestamp when the object was created.
    :type created_on: str
    :param default: If it's the default player used on embedded videos.
    :type default: bool
    :param description: Description of the player.
    :type description: str
    :param id_: ID of the object.
    :type id_: str
    :param logo: Whether the logo inside the player is displayed.
    :type logo: bool
    :param logo_control_bar: Whether the logo in the control bar is displayed.
    :type logo_control_bar: bool
    :param logo_control_bar_link: Link to the control bar logo image.
    :type logo_control_bar_link: str
    :param logo_link: Link to the logo image.
    :type logo_link: str
    :param logo_position: logo_position
    :type logo_position: PlayerLogoPosition
    :param preview_url: Link to demo the player configuration.
    :type preview_url: str
    :param quality_menu: Whether to display the video quality menu.
    :type quality_menu: bool
    :param rewind_button: Show the rewind button.
    :type rewind_button: bool
    :param share_menu: Whether to display the share menu.
    :type share_menu: bool
    :param show_minithumbs: Whether to display minithumbs.
    :type show_minithumbs: bool
    :param show_title: Show the video title on top.
    :type show_title: bool
    :param skin: skin
    :type skin: PlayerSkin
    :param speed_menu: Whether to display the speed menu.
    :type speed_menu: bool
    :param title: Player title that is displayed in admin.
    :type title: str
    :param title_logo: Whether the title icon is displayed.
    :type title_logo: bool
    :param title_logo_link: Link to the title logo image.
    :type title_logo_link: str
    :param zoom_menu: Whether to display the zoom menu.
    :type zoom_menu: bool
    """

    def __init__(
        self,
        created_on: str,
        default: bool,
        description: str,
        id_: str,
        logo: bool,
        logo_control_bar: bool,
        logo_control_bar_link: str,
        logo_link: str,
        logo_position: PlayerLogoPosition,
        preview_url: str,
        quality_menu: bool,
        rewind_button: bool,
        share_menu: bool,
        show_minithumbs: bool,
        show_title: bool,
        skin: PlayerSkin,
        speed_menu: bool,
        title: str,
        title_logo: bool,
        title_logo_link: str,
        zoom_menu: bool,
    ):
        """Player

        :param created_on: Timestamp when the object was created.
        :type created_on: str
        :param default: If it's the default player used on embedded videos.
        :type default: bool
        :param description: Description of the player.
        :type description: str
        :param id_: ID of the object.
        :type id_: str
        :param logo: Whether the logo inside the player is displayed.
        :type logo: bool
        :param logo_control_bar: Whether the logo in the control bar is displayed.
        :type logo_control_bar: bool
        :param logo_control_bar_link: Link to the control bar logo image.
        :type logo_control_bar_link: str
        :param logo_link: Link to the logo image.
        :type logo_link: str
        :param logo_position: logo_position
        :type logo_position: PlayerLogoPosition
        :param preview_url: Link to demo the player configuration.
        :type preview_url: str
        :param quality_menu: Whether to display the video quality menu.
        :type quality_menu: bool
        :param rewind_button: Show the rewind button.
        :type rewind_button: bool
        :param share_menu: Whether to display the share menu.
        :type share_menu: bool
        :param show_minithumbs: Whether to display minithumbs.
        :type show_minithumbs: bool
        :param show_title: Show the video title on top.
        :type show_title: bool
        :param skin: skin
        :type skin: PlayerSkin
        :param speed_menu: Whether to display the speed menu.
        :type speed_menu: bool
        :param title: Player title that is displayed in admin.
        :type title: str
        :param title_logo: Whether the title icon is displayed.
        :type title_logo: bool
        :param title_logo_link: Link to the title logo image.
        :type title_logo_link: str
        :param zoom_menu: Whether to display the zoom menu.
        :type zoom_menu: bool
        """
        self.created_on = created_on
        self.default = default
        self.description = self._define_str("description", description, max_length=500)
        self.id_ = id_
        self.logo = logo
        self.logo_control_bar = logo_control_bar
        self.logo_control_bar_link = self._define_str(
            "logo_control_bar_link",
            logo_control_bar_link,
            nullable=True,
            min_length=1,
            max_length=2083,
        )
        self.logo_link = self._define_str(
            "logo_link", logo_link, nullable=True, min_length=1, max_length=2083
        )
        self.logo_position = self._enum_matching(
            logo_position, PlayerLogoPosition.list(), "logo_position"
        )
        self.preview_url = self._define_str(
            "preview_url", preview_url, min_length=1, max_length=2083
        )
        self.quality_menu = quality_menu
        self.rewind_button = rewind_button
        self.share_menu = share_menu
        self.show_minithumbs = show_minithumbs
        self.show_title = show_title
        self.skin = self._enum_matching(skin, PlayerSkin.list(), "skin")
        self.speed_menu = speed_menu
        self.title = self._define_str("title", title, max_length=50)
        self.title_logo = title_logo
        self.title_logo_link = self._define_str(
            "title_logo_link",
            title_logo_link,
            nullable=True,
            min_length=1,
            max_length=2083,
        )
        self.zoom_menu = zoom_menu
