# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .utils.base_model import BaseModel
from .tt_auto_lang import TtAutoLang


@JsonMap({"id_": "id"})
class Project(BaseModel):
    """Project

    :param auto_tt: List of language codes to automatically transcribe the audio of all uploaded videos.
    :type auto_tt: List[TtAutoLang]
    :param created_on: Timestamp when the object was created.
    :type created_on: str
    :param description: Description of the project.
    :type description: str
    :param id_: ID of the object.
    :type id_: str
    :param published: Public videos can only be viewed when the project is published. Otherwise you'll need a private link or a password.
    :type published: bool
    :param timezone: Timezone of the project.
    :type timezone: str
    :param title: Title of the project.
    :type title: str
    """

    def __init__(
        self,
        auto_tt: List[TtAutoLang],
        created_on: str,
        description: str,
        id_: str,
        published: bool,
        timezone: str,
        title: str,
    ):
        """Project

        :param auto_tt: List of language codes to automatically transcribe the audio of all uploaded videos.
        :type auto_tt: List[TtAutoLang]
        :param created_on: Timestamp when the object was created.
        :type created_on: str
        :param description: Description of the project.
        :type description: str
        :param id_: ID of the object.
        :type id_: str
        :param published: Public videos can only be viewed when the project is published. Otherwise you'll need a private link or a password.
        :type published: bool
        :param timezone: Timezone of the project.
        :type timezone: str
        :param title: Title of the project.
        :type title: str
        """
        self.auto_tt = self._define_list(auto_tt, TtAutoLang)
        self.created_on = created_on
        self.description = description
        self.id_ = id_
        self.published = published
        self.timezone = timezone
        self.title = title
