# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from .utils.json_map import JsonMap
from .utils.base_model import BaseModel
from .text_track_status import TextTrackStatus
from .text_track_type import TextTrackType


@JsonMap({"id_": "id", "type_": "type"})
class TextTrack(BaseModel):
    """TextTrack

    :param cdn_link: Link to the file served by CDN. URL expires after 24 hours by default.
    :type cdn_link: str
    :param default: If the text track is the default one pre-selected.
    :type default: bool
    :param id_: ID of the object.
    :type id_: str
    :param lang_code: Language code of the object in the BCP 47 specification.
    :type lang_code: str
    :param status: status
    :type status: TextTrackStatus
    :param title: Title of the text track.
    :type title: str
    :param type_: type_
    :type type_: TextTrackType
    """

    def __init__(
        self,
        cdn_link: str,
        default: bool,
        id_: str,
        lang_code: str,
        status: TextTrackStatus,
        title: str,
        type_: TextTrackType,
    ):
        """TextTrack

        :param cdn_link: Link to the file served by CDN. URL expires after 24 hours by default.
        :type cdn_link: str
        :param default: If the text track is the default one pre-selected.
        :type default: bool
        :param id_: ID of the object.
        :type id_: str
        :param lang_code: Language code of the object in the BCP 47 specification.
        :type lang_code: str
        :param status: status
        :type status: TextTrackStatus
        :param title: Title of the text track.
        :type title: str
        :param type_: type_
        :type type_: TextTrackType
        """
        self.cdn_link = cdn_link
        self.default = default
        self.id_ = id_
        self.lang_code = lang_code
        self.status = self._enum_matching(status, TextTrackStatus.list(), "status")
        self.title = title
        self.type_ = self._enum_matching(type_, TextTrackType.list(), "type_")
